#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/**
	Function to calculate the magnitude of an image
	
	Fraga May 30, 2001
**/

#define fmodulo( a, b ) log(1.0 + sqrt( a*a + b*b ))
// #define fmodulo( a, b ) sqrt( a*a + b*b )

void spectrum( float **imgin, float **imgModulo, int rows, int cols )
{
	#define Re(i,j)  imgin[i][2*(j)]
	#define Im(i,j)  imgin[i][2*(j)+1]

	int i, j, c2;
	float val;

	/* We'll going to calculate the modulo of the transform  */

	c2 = cols/2;

	for ( i=0; i<rows ; i++ )
		imgModulo[i][0] = fmodulo( imgin[i][0], imgin[i][1] );
		 
	for ( j=1; j<c2;  j++) { 
		val = fmodulo( Re(0,j), Im(0,j) );
		imgModulo[0][  j   ] = val;
		imgModulo[0][cols-j] = val;
	}
	for (i=1; i<rows ; i++) {
		for (j=1; j<c2;  j++) {
			val = fmodulo( Re(i,j), Im(i,j) );
			imgModulo[i][j] = val; 
			imgModulo[rows-i][cols-j] = val;
		}
	}
	for ( i=0; i<rows ; i++ )
		imgModulo[i][c2] = fmodulo( imgin[i][2*c2], imgin[i][2*c2 + 1] );
}

void filter( float **img, int rows, int cols, int r )
{
	int i, j;
	int c2=cols/2;
	int r2 = r*r;
	float cx, cy, x, y;

	cy = (rows-1)/2.0;
	cx = (cols-1)/2.0;

	for (i=0; i<rows ; i++) {
		for (j=0; j<=c2;  j++) {
			x = j - cx;
			y = i - cx;
			if ( x*x + y*y > r2 ) {
				img[i][2*j] = 0; 
				img[i][2*j+1] = 0;
			}
		}
	}
}
