#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "matrix.h"

void strmfe ( char *new, char *old, char *ext )
{
	while ( *old != 0 && *old != '.' ) *new++ = *old++;
	*new++ = '.';
	while ( *ext ) *new++ = *ext++;
	*new = 0;
}


MATRIX *matrix_allocate (unsigned int rows, unsigned int cols, int element_size)
{
	int i;
	MATRIX *A;
	char **paux;

	/** Allocate the matrix structure **/
	A = (MATRIX *) malloc ( sizeof( MATRIX ) );
	if ( !A ) {
		fprintf( stderr, "\nERROR en colocar la estructura de la matriz\n");
		exit (1);
	}
	/** Set size as requiered **/
	A->rows = rows;
	A->cols = cols;
	A->element_size = element_size;

/** Try to allocate the request **/
	switch ( element_size ) {

		case  sizeof( byte ): 
			A->type = 5;
			break;
		case  sizeof( float ): 
			A->type = 9;
			break;
		case  sizeof( double ): 
			A->type = 10;
			break;
		default:
			fprintf( stderr, "\nERROR en localizar matriz: tipo no soportado\n");
			exit(1);
	}
	paux = ( char **) malloc ( rows * sizeof( char *) );
	if ( !paux ) {
		fprintf( stderr, "\nERROR haciendo apuntadores en %dx%d matrix de caracteres\n", rows, cols );
		exit(1);
	}
	for ( i=0; i<rows; i++ ) {
		paux[i] = (char *) malloc( cols * element_size );
		if( !paux[i] ) {
			fprintf( stderr, "\nError haciendo rengln %d en %dx%d  matriz de caracteres\n", i, rows, cols );
			exit(1);
		}
	}
	A->ptr = (void ** ) paux;

	return( A );
}


void matrix_free( MATRIX *A )
{
	int i;
	char **a;

	a = (char **)A->ptr;
	for ( i=0; i<A->rows; i++ ) free( a[i] );

	free ( a );
	free ( A );
}
