#ifndef MATRIX_H
#define MATRIX_H 1

typedef unsigned char byte;

typedef struct {
	int element_size;
	int type;
	unsigned int rows;
	unsigned int cols;
	void **ptr;
} MATRIX;

/** 
    type = 0   1 bit/pixel, 0 is write
    type = 1   1 bit/pixel, 1 is black
    type = 2   4 bits/pixel, 16 grey tones
    type = 3   4 bits/pixel, palette 16 colors
    type = 4   8 bits/pixel, palette 256 colors 
    type = 5   8 bits/pixel, 256 grey tones
    type = 6   24 bits/pixel, RGB
    type = 7   16 bits/pixel, short integers matrix 
    type = 8   32 bits/pixel, integers matrix 
    type = 9   32 bits/pixel, floats matrix 
    type = 10  64 bits/pixel, doubles matrix 
**/

void strmfe ( char *new, char *old, char *ext);

MATRIX *matrix_allocate (unsigned int rows,unsigned int cols, int size );

void matrix_free(MATRIX *);

#endif
